'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setTabs = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _addons = require('@storybook/addons');

var _addons2 = _interopRequireDefault(_addons);

var _prismjs = require('prismjs');

var _prismjs2 = _interopRequireDefault(_prismjs);

require('prismjs/components/prism-typescript.js');

require('prismjs/components/prism-sass.js');

require('prismjs/themes/prism.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Code = function (_React$Component) {
  _inherits(Code, _React$Component);

  function Code(props, context) {
    _classCallCheck(this, Code);

    var _this = _possibleConstructorReturn(this, (Code.__proto__ || Object.getPrototypeOf(Code)).call(this, props, context));

    _this.state = { code: '' };
    _this.channelName = 'soft/code/add_' + props.type;
    _this.onSelectTab = _this.onSelectTab.bind(_this);
    return _this;
  }

  _createClass(Code, [{
    key: 'onSelectTab',
    value: function onSelectTab(_ref) {
      var code = _ref.code,
          type = _ref.type;

      var formattedCode = type && code && _prismjs2.default.highlight(code, _prismjs2.default.languages[type]);

      this.setState({ code: formattedCode });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          channel = _props.channel,
          api = _props.api;

      channel.on(this.channelName, this.onSelectTab);

      this.stopListeningOnStory = api.onStory(function () {
        _this2.onSelectTab('');
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var code = this.state.code;
      var type = this.props.type;

      return _react2.default.createElement(
        'div',
        null,
        code ? _react2.default.createElement(
          'pre',
          null,
          _react2.default.createElement(
            'code',
            null,
            _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: code } })
          )
        ) : _react2.default.createElement(
          'p',
          null,
          ' No ',
          type,
          ' code Found '
        )
      );
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.stopListeningOnStory) {
        this.stopListeningOnStory();
      }

      this.unmounted = true;
      var _props2 = this.props,
          channel = _props2.channel,
          api = _props2.api;

      channel.removeListener(this.channelName, this.onSelectTab);
    }
  }]);

  return Code;
}(_react2.default.Component);

var registerTab = function registerTab(_ref2) {
  var label = _ref2.label,
      type = _ref2.type;

  _addons2.default.register('soft/code/add_' + type, function (api) {
    _addons2.default.addPanel('soft/' + type + '/panel', {
      title: label,
      render: function render() {
        return _react2.default.createElement(Code, { channel: _addons2.default.getChannel(), api: api, type: type });
      }
    });
  });
};
var setTabs = exports.setTabs = function setTabs(tabs) {
  var tabsToRender = [].concat(tabs);
  tabsToRender.forEach(function (t) {
    return registerTab(t);
  });
};